Index: /trunk/src/org/expeditee/items/Text.java
===================================================================
--- /trunk/src/org/expeditee/items/Text.java	(revision 120)
+++ /trunk/src/org/expeditee/items/Text.java	(revision 121)
@@ -182,4 +182,12 @@
 	}
 
+	@Override
+	public Color getHighlightColor() {
+		if (_highlightColor.equals(getPaintBackgroundColor()))
+			return ALTERNATE_HIGHLIGHT;
+		return _highlightColor;
+	}
+
+	
 	/**
 	 * Sets the justification of this Text item. The given integer should
@@ -225,6 +233,9 @@
 	 */
 	public void setText(String text) {
+	//	if (_text != null && text.length() < _text.length())
+	//		invalidateAll();
 		_text = new StringBuffer(text);
 		rebuild(false);
+	//	invalidateAll();
 	}
 
@@ -265,6 +276,10 @@
 	 */
 	public void removeText(String text) {
-		if (_text.length() > 0 && _text.indexOf(text) == 0)
+		
+		if (_text.length() > 0 && _text.indexOf(text) == 0) {
+			//invalidateAll();
 			_text.delete(0, text.length());
+		}
+		
 
 	}
@@ -273,4 +288,5 @@
 		int length = _text.length();
 		if (length > 0) {
+			//invalidateAll();
 			int pos = _text.indexOf(textToRemove);
 			int textToRemoveLength = textToRemove.length();
@@ -279,4 +295,5 @@
 			}
 		}
+		
 	}
 
@@ -411,4 +428,5 @@
 		TextHitInfo hit = getCharPosition(line, mouseX);
 		_selectionStart = hit.getInsertionIndex() + _lineOffsets.get(line);
+		invalidateAll();
 	}
 
@@ -420,4 +438,5 @@
 		TextHitInfo hit = getCharPosition(line, mouseX);
 		_selectionEnd = hit.getInsertionIndex() + _lineOffsets.get(line);
+		invalidateAll();
 	}
 
@@ -425,8 +444,10 @@
 		_selectionStart = -1;
 		_selectionEnd = -1;
+		invalidateAll();
 	}
 
 	public void clearSelectionEnd() {
 		_selectionEnd = -1;
+		invalidateAll();
 	}
 
@@ -448,5 +469,8 @@
 		if (_selectionStart < 0 || _selectionEnd < 0)
 			return null;
-		else if (_selectionEnd > _text.length())
+		
+		invalidateAll();
+		
+		if (_selectionEnd > _text.length())
 			_selectionEnd = _text.length();
 
@@ -459,4 +483,6 @@
 		_text.insert(left, newText);
 		rebuild(true);
+		
+		invalidateAll();
 
 		return s;
@@ -493,4 +519,6 @@
 		TextLayout current = null;
 		int line;
+		
+		invalidateAll();
 
 		// check for empty string
@@ -635,4 +663,7 @@
 						x,
 						(getX() - Item.MARGIN_RIGHT - (2 * getGravity()) + getBoundsWidth()));
+		
+		invalidateAll();
+		
 		return new Point2D.Float(Math.round(x), Math.round(getY() + y
 				+ caret[1]));
@@ -777,6 +808,6 @@
 	public void setFont(Font font) {
 		// all decoding occurs in the Utils class
+		
 		_font = font;
-
 		// rejustify();
 		rebuild(false);
@@ -1105,5 +1136,5 @@
 			return;
 		}
-
+		
 		AttributedString paragraphText = new AttributedString(_text.toString());
 		paragraphText.addAttribute(TextAttribute.FONT, getPaintFont());
@@ -1154,4 +1185,5 @@
 
 		updatePolygon();
+		
 	}
 
@@ -1515,4 +1547,7 @@
 			_lineBreaker.deleteChar(inserting.getIterator(), pos);
 		}
+		
+		
+		
 	}
 
@@ -1682,4 +1717,5 @@
 	@Override
 	protected int getLinkYOffset() {
+		if (_textLayouts.size() == 0) return  0;
 		return Math.round(-(_textLayouts.get(0).getAscent() / 2));
 	}
Index: /trunk/src/org/expeditee/items/WidgetCorner.java
===================================================================
--- /trunk/src/org/expeditee/items/WidgetCorner.java	(revision 120)
+++ /trunk/src/org/expeditee/items/WidgetCorner.java	(revision 121)
@@ -1,5 +1,8 @@
 package org.expeditee.items;
 
+import java.awt.Color;
 import java.awt.Graphics2D;
+import java.awt.Polygon;
+import java.awt.geom.Point2D;
 
 
@@ -10,4 +13,7 @@
 	WidgetCorner(int x, int y, int id, InteractiveWidget widgetSource) {
 		super(x, y, id);
+		
+		super.setThickness(2.0f);
+		
 		if (widgetSource == null) throw new NullPointerException("widgetSource");
 		_widgetSource = widgetSource;
@@ -22,9 +28,27 @@
 	@Override
 	public void setPosition(float x, float y) {
+		invalidateFill();
+		if (_widgetSource != null) { // _widgetSource == null on construction
+			if (!_widgetSource.setPositions(this,(int)(x+0.5),(int)(y+0.5))) {
+				super.setPosition(x, y);
+			}
+		} else super.setPosition(x, y);
+		invalidateFill();
+	}
+	
+	@Override
+	public void setXY(float x, float y) {
+		invalidateFill();
+		if (_widgetSource != null) { // _widgetSource == null on construction
+			if (!_widgetSource.setPositions(this,(int)(x+0.5),(int)(y+0.5))) {
+				super.setXY(x, y);
+			}
+		} else super.setXY(x, y);
+		invalidateFill();
+	}
 
-		if (_widgetSource != null) { // _widgetSource == null on construction
-			if (!_widgetSource.setPositions(this,(int)(x+0.5),(int)(y+0.5)))
-				super.setPosition(x, y);
-		} else super.setPosition(x, y);
+	@Override
+	public void translate(Point2D origin, double ratio) {
+		//super.translate(origin, ratio);
 	}
 
@@ -41,5 +65,5 @@
 	@Override
 	public void paint(Graphics2D g) {
-		if (InteractiveWidget.isExepiteeHighlightingEnabled()) { // only paint if flag is set to true
+		if (InteractiveWidget.isExpediteeHighlightingEnabled()) { // only paint if flag is set to true
 			
 			// For fixed widgets, always have corner selected with connected context
@@ -51,5 +75,9 @@
 			_mode = tmp; // restore mode
 		}
-		_widgetSource.paint(g, this);	
+	}
+	
+	@Override
+	public void paintFill(Graphics2D g) {
+		_widgetSource.paintFill(g); // only paints a fill if floating
 	}
 	
@@ -69,5 +97,51 @@
 		return "WidgetCorner: [" + this.getX() + "," +  this.getY() + "]";
 	}
+
+	@Override
+	public void setThickness(float thick) {
+	}
+
+	@Override
+	public void setArrow(float length, double ratio) {
+	}
+
+	@Override
+	public void setArrowhead(Polygon arrow) {
+	}
+
+	@Override
+	public void setArrowheadLength(float length) {
+	}
+
+	@Override
+	public void setArrowheadRatio(double ratio) {
+	}
+
+	@Override
+	public void setBackgroundColor(Color c) {
+	}
+
+	@Override
+	public void setBottomShadowColor(Color bottom) {
+	}
+
+	@Override
+	public void setFillColor(Color c) {
+	}
+
+	@Override
+	public void setFillPattern(String patternLink) {
+	}
+
+	@Override
+	public void toggleDashed(int amount) {
+	}
+
+	@Override
+	public void setSize(float size) {
+	}
+
+
 	
-	
+
 }
Index: /trunk/src/org/expeditee/items/WidgetEdge.java
===================================================================
--- /trunk/src/org/expeditee/items/WidgetEdge.java	(revision 120)
+++ /trunk/src/org/expeditee/items/WidgetEdge.java	(revision 121)
@@ -2,4 +2,5 @@
 
 import java.awt.Color;
+import java.awt.Polygon;
 
 /**
@@ -60,4 +61,38 @@
 	}
 
-	
+	@Override
+	public void setArrow(float length, double ratio) {
+	}
+
+	@Override
+	public void setArrowhead(Polygon arrow) {
+	}
+
+	@Override
+	public void setArrowheadLength(float length) {
+	}
+
+	@Override
+	public void setArrowheadRatio(double ratio) {
+	}
+
+	@Override
+	public void setBackgroundColor(Color c) {
+	}
+
+	@Override
+	public void setBottomShadowColor(Color bottom) {
+	}
+
+	@Override
+	public void setFillColor(Color c) {
+	}
+
+	@Override
+	public void setFillPattern(String patternLink) {
+	}
+
+	@Override
+	public void setSize(float size) {
+	}
 }
Index: /trunk/src/org/expeditee/items/XRayable.java
===================================================================
--- /trunk/src/org/expeditee/items/XRayable.java	(revision 120)
+++ /trunk/src/org/expeditee/items/XRayable.java	(revision 121)
@@ -107,5 +107,7 @@
 	@Override
 	public void setThickness(float thick) {
+		this.invalidateCommonTrait(ItemAppearence.Thickness);
 		_source.setThickness(thick);
+		this.invalidateCommonTrait(ItemAppearence.Thickness);
 	}
 	
@@ -171,4 +173,5 @@
 	public void setPosition(float x, float y) {
 		//_source.setPosition(x, y);
+		
 	}
 	
Index: /trunk/src/org/expeditee/simple/Context.java
===================================================================
--- /trunk/src/org/expeditee/simple/Context.java	(revision 120)
+++ /trunk/src/org/expeditee/simple/Context.java	(revision 121)
@@ -9,6 +9,6 @@
 import org.expeditee.actions.Simple;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Text;
 
@@ -40,5 +40,5 @@
 	public void display() {
 		if (size() == 0) {
-			FrameGraphics.ErrorMessage("No variables exist!");
+			MessageBay.errorMessage("No variables exist!");
 			return;
 		}
@@ -238,5 +238,5 @@
 		}
 		if (!success && Simple.isVerbose())
-			FrameGraphics.WarningMessage("Error creating " + framesetName);
+			MessageBay.warningMessage("Error creating " + framesetName);
 		if (successVar != null) {
 			primitives_.setValue(successVar, new SBoolean(success));
Index: /trunk/src/org/expeditee/simple/Variables.java
===================================================================
--- /trunk/src/org/expeditee/simple/Variables.java	(revision 120)
+++ /trunk/src/org/expeditee/simple/Variables.java	(revision 121)
@@ -3,5 +3,5 @@
 import java.util.ArrayList;
 
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.MessageBay;
 
 public abstract class Variables<T extends SVariable<?>> {
@@ -23,5 +23,5 @@
 	public void display() {
 		for (T v : list_) {
-			FrameGraphics.DisplayMessage(v.getName() + ": " + v.stringValue());
+			MessageBay.displayMessage(v.getName() + ": " + v.stringValue());
 		}
 	}
Index: /trunk/src/org/expeditee/stats/TreeStats.java
===================================================================
--- /trunk/src/org/expeditee/stats/TreeStats.java	(revision 120)
+++ /trunk/src/org/expeditee/stats/TreeStats.java	(revision 121)
@@ -6,6 +6,6 @@
 
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.io.Logger;
 import org.expeditee.items.Item;
@@ -27,5 +27,5 @@
 		super(topFrame);
 		visited.add(_name.toLowerCase());
-		FrameGraphics.OverwriteMessage("Computed: " + _name);
+		MessageBay.overwriteMessage("Computed: " + _name);
 
 		// Initialise variables with the data for this frames comet
